<< problem 303 - Multiples with small digits | Paper-strip Game - problem 306 >> |
Problem 304: Primonacci
(see projecteuler.net/problem=304)
For any positive integer n the function next\_prime(n) returns the smallest prime p such that p > n.
The sequence a(n) is defined by:
a(1)=next\_prime(10^14) and a(n)=next\_prime(a(n-1)) for n>1.
The fibonacci sequence f(n) is defined by: f(0)=0, f(1)=1 and f(n)=f(n-1)+f(n-2) for n>1.
The sequence b(n) is defined as f(a(n)).
Find sum{b(n)} for 1<=n<=100 000. Give your answer mod 1234567891011.
My Algorithm
I need two thing for the problem: a fast Fibonacci generator and a prime test for large numbers.
My toolbox already has a Miller-Rabin test, that means I only have to find a fast Fibonacci generator.
Last week I solved problem 137 with the matrix form found on en.wikipedia.org/wiki/Fibonacci_number
Using those two tools I can easily compute F(10^14) and test each consecutive Fibonacci number until I have 100000 primes.
Alternative Approaches
When I read the Wikipedia a second time I noted a simplification of the matrix form called "fast doubling" on other websites:
F_{2n-1} = F^2_n + F^2_{n-1}
F_{2n} = F_n (2 F_{n-1} + F_n)
My function fibonacci
implements that algorithm. It's about 2 to 3x faster than fibonacciMatrix
(from problem 137).
Unfortunately, looking for the initial Fibonacci numbers poses a tiny fraction of the overall computation time.
Therefore it doesn't make a difference - but hopefully my new fibonacci
function can be used in other problems, too.
I played around with my trusted powmod
function, too. It's pretty fast when compiled with GCC but noticeable slower
with Visual C++ because of its lack of 128-bit integer arithmetic.
Based on the discussion apps.topcoder.com/forums/?module=Thread&threadID=670443&start=0&mc=10 I wrote a second
powmod
which is about 30% faster on Visual C++ and doesn't need a mulmod
function.
The old powmod
still remains my fastest implementation of powmod
for GCC.
All these little optimizations caused a little bit of code bloat - that's one of my longest solutions to a Project Euler problem ...
(actually it became the new number 1 spot on my list).
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "10000 10000 10000000000" | ./304
Output:
Note: the original problem's input 100000000000000 100000 1234567891011
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
// ---------- mulmod, powmod and Miller-Rabin test from my toolbox ----------
// return (a*b) % modulo
unsigned long long mulmod(unsigned long long a, unsigned long long b, unsigned long long modulo)
{
// (a * b) % modulo = (a % modulo) * (b % modulo) % modulo
a %= modulo;
b %= modulo;
// fast path
if (a <= 0xFFFFFFF && b <= 0xFFFFFFF)
return (a * b) % modulo;
// we might encounter overflows (slow path)
// the number of loops depends on b, therefore try to minimize b
if (b > a)
std::swap(a, b);
#ifndef __GNUC__
// bitwise multiplication
unsigned long long result = 0;
while (a > 0 && b > 0)
{
// b is odd ? a*b = a + a*(b-1)
if (b & 1)
{
result += a;
if (result >= modulo)
result -= modulo;
// skip b-- because the bit-shift at the end will remove the lowest bit anyway
}
// b is even ? a*b = (2*a)*(b/2)
a <<= 1;
if (a >= modulo)
a -= modulo;
// next bit
b >>= 1;
}
return result;
#else
// based on GCC's 128 bit implementation
return ((unsigned __int128)a * b) % modulo;
#endif
}
#ifdef __GNUC__
// return (base^exponent) % modulo => simple implementation
unsigned long long powmod(unsigned long long base, unsigned long long exponent, unsigned long long modulo)
{
unsigned long long result = 1;
while (exponent > 0)
{
// fast exponentation:
// odd exponent ? a^b = a*a^(b-1)
if (exponent & 1)
result = mulmod(result, base, modulo);
// even exponent ? a^b = (a*a)^(b/2)
base = mulmod(base, base, modulo);
exponent >>= 1;
}
return result;
}
#else
// return (base^exponent) % modulo => faster implementation
unsigned long long powmod(unsigned long long base, unsigned long long exponent, unsigned long long modulo)
{
// based on https://apps.topcoder.com/forums/?module=Thread&threadID=670443&start=0&mc=10
// fastest generic code (but slower than G++ optimized code)
unsigned long long result = 1;
base %= modulo;
while (exponent > 0)
{
// odd exponent ? a^b = a*a^(b-1)
if (exponent & 1)
{
// "unrolled" code of:
// result = mulmod(result, base, modulo);
// base = mulmod(base, base, modulo);
auto x = result;
auto y = base;
auto b = base;
result = 0;
base = 0;
while (b > 0)
{
if (b & 1)
{
result += x; if (result >= modulo) result -= modulo;
base += y; if (base >= modulo) base -= modulo;
}
x += x; if (x >= modulo) x -= modulo;
y += y; if (y >= modulo) y -= modulo;
b >>= 1;
}
}
else
{
// even exponent ? a^b = (a*a)^(b/2)
auto y = base;
auto b = base;
base = 0;
while (b > 0)
{
if (b & 1)
{
base += y; if (base >= modulo) base -= modulo;
}
y += y; if (y >= modulo) y -= modulo;
b >>=1;
}
}
exponent >>=1;
}
return result;
}
#endif
// Miller-Rabin-test
bool isPrime(unsigned long long p)
{
// IMPORTANT: requires mulmod(a, b, modulo) and powmod(base, exponent, modulo)
// some code from https://ronzii.wordpress.com/2012/03/04/miller-rabin-primality-test/
// with optimizations from http://ceur-ws.org/Vol-1326/020-Forisek.pdf
// good bases can be found at http://miller-rabin.appspot.com/
// trivial cases
const unsigned int bitmaskPrimes2to31 = (1 << 2) | (1 << 3) | (1 << 5) | (1 << 7) |
(1 << 11) | (1 << 13) | (1 << 17) | (1 << 19) |
(1 << 23) | (1 << 29); // = 0x208A28Ac
if (p < 31)
return (bitmaskPrimes2to31 & (1 << p)) != 0;
if (p % 2 == 0 || p % 3 == 0 || p % 5 == 0 || p % 7 == 0 || // divisible by a small prime
p % 11 == 0 || p % 13 == 0 || p % 17 == 0)
return false;
if (p < 17*19) // we filtered all composite numbers < 17*19, all others below 17*19 must be prime
return true;
// fine-tuning for the problem:
// fast check of more small primes (up to 100)
if (p % 19 == 0 || p % 23 == 0 || p % 29 == 0 || p % 31 == 0 || p % 37 == 0 ||
p % 41 == 0 || p % 43 == 0 || p % 47 == 0 || p % 53 == 0 || p % 59 == 0 ||
p % 61 == 0 || p % 67 == 0 || p % 71 == 0 || p % 73 == 0 || p % 79 == 0 ||
p % 83 == 0 || p % 89 == 0 || p % 97 == 0)
return false;
// test p against those numbers ("witnesses")
// good bases can be found at http://miller-rabin.appspot.com/
const unsigned int STOP = 0;
const unsigned int TestAgainst1[] = { 377687, STOP };
const unsigned int TestAgainst2[] = { 31, 73, STOP };
const unsigned int TestAgainst3[] = { 2, 7, 61, STOP };
// first three sequences are good up to 2^32
const unsigned int TestAgainst4[] = { 2, 13, 23, 1662803, STOP };
const unsigned int TestAgainst7[] = { 2, 325, 9375, 28178, 450775, 9780504, 1795265022, STOP };
// good up to 2^64
const unsigned int* testAgainst = TestAgainst7;
// use less tests if feasible
if (p < 5329)
testAgainst = TestAgainst1;
else if (p < 9080191)
testAgainst = TestAgainst2;
else if (p < 4759123141ULL)
testAgainst = TestAgainst3;
else if (p < 1122004669633ULL)
testAgainst = TestAgainst4;
// find p - 1 = d * 2^j
auto d = p - 1;
d >>= 1;
unsigned int shift = 0;
while ((d & 1) == 0)
{
shift++;
d >>= 1;
}
// test p against all bases
do
{
auto x = powmod(*testAgainst++, d, p);
// is test^d % p == 1 or -1 ?
if (x == 1 || x == p - 1)
continue;
// now either prime or a strong pseudo-prime
// check test^(d*2^r) for 0 <= r < shift
bool maybePrime = false;
for (unsigned int r = 0; r < shift; r++)
{
// x = x^2 % p
// (initial x was test^d)
x = mulmod(x, x, p);
// x % p == 1 => not prime
if (x == 1)
return false;
// x % p == -1 => prime or an even stronger pseudo-prime
if (x == p - 1)
{
// next iteration
maybePrime = true;
break;
}
}
// not prime
if (!maybePrime)
return false;
} while (*testAgainst != STOP);
// prime
return true;
}
// ---------- compute Fibonacci % modulo ----------
// version 1: matrix algorithm
unsigned long long fibonacciMatrix(unsigned long long n, unsigned long long modulo)
{
// fast exponentiation: same idea as powmod from my toolbox
// matrix values from https://en.wikipedia.org/wiki/Fibonacci_number#Matrix_form
unsigned long long fibo [2][2]= { { 1, 1 },
{ 1, 0 } };
// initially identity matrix
unsigned long long result[2][2]= { { 1, 0 }, // { { F(n+1), F(n) },
{ 0, 1 } }; // { F(n), F(n-1) } }
while (n > 0)
{
// fast exponentation:
// odd exponent ? a^n = a*a^(n-1)
if (n & 1)
{
// compute new values, store them in temporaries
auto t00 = mulmod(result[0][0], fibo[0][0], modulo) + mulmod(result[0][1], fibo[1][0], modulo);
auto t01 = mulmod(result[0][0], fibo[0][1], modulo) + mulmod(result[0][1], fibo[1][1], modulo);
auto t10 = mulmod(result[1][0], fibo[0][0], modulo) + mulmod(result[1][1], fibo[1][0], modulo);
auto t11 = mulmod(result[1][0], fibo[0][1], modulo) + mulmod(result[1][1], fibo[1][1], modulo);
if (t00 >= modulo) t00 -= modulo;
if (t01 >= modulo) t01 -= modulo;
if (t10 >= modulo) t10 -= modulo;
if (t11 >= modulo) t11 -= modulo;
// copy back to matrix
result[0][0] = t00; result[0][1] = t01;
result[1][0] = t10; result[1][1] = t11;
}
// even exponent ? a^n = (a*a)^(n/2)
// compute new values, store them in temporaries
auto t00 = mulmod(fibo[0][0], fibo[0][0], modulo) + mulmod(fibo[0][1], fibo[1][0], modulo);
auto t01 = mulmod(fibo[0][0], fibo[0][1], modulo) + mulmod(fibo[0][1], fibo[1][1], modulo);
auto t10 = mulmod(fibo[1][0], fibo[0][0], modulo) + mulmod(fibo[1][1], fibo[1][0], modulo);
auto t11 = mulmod(fibo[1][0], fibo[0][1], modulo) + mulmod(fibo[1][1], fibo[1][1], modulo);
if (t00 >= modulo) t00 -= modulo;
if (t01 >= modulo) t01 -= modulo;
if (t10 >= modulo) t10 -= modulo;
if (t11 >= modulo) t11 -= modulo;
// copy back to matrix
fibo[0][0] = t00; fibo[0][1] = t01;
fibo[1][0] = t10; fibo[1][1] = t11;
n >>= 1;
}
return result[0][1]; // same as result[1][0]
}
// version 2: fast doubling algorithm, modulo < 2^62
unsigned long long fibonacci(unsigned long long n, unsigned long long modulo)
{
// extract highest bit
auto bit = n;
while (bit & (bit - 1))
bit &= bit - 1;
// F(0) and F(1)
auto a = 0ULL;
auto b = 1ULL;
// from highest to lowest bit
while (bit != 0)
{
// F(2n) = F(n) * (2 * F(n+1) - F(n))
auto nextA = mulmod(a, 2*b + modulo - a, modulo); // plus modulo to avoid negative results
// F(2n+1) = F(n)^2 + F(n+1)^2
b = mulmod(a, a, modulo) + mulmod(b, b, modulo);
if (b >= modulo)
b -= modulo;
a = nextA;
// odd ?
if (n & bit)
{
// one step further, need F(2n+1) and F(2n+2)
auto next = a + b;
if (next >= modulo)
next -= modulo;
a = b;
b = next;
}
bit >>= 1;
}
return a;
}
int main()
{
auto n = 100000000000000ULL;
auto numPrimes = 100000;
auto Modulo = 1234567891011ULL;
std::cin >> n >> numPrimes >> Modulo;
// F(n) = F(n-1) + F(n-2)
// my "seed" values to find F(10^14 + x)
auto last = fibonacci(n - 1, Modulo); // replace by fibonacciMatrix for the other algorithm
auto current = fibonacci(n , Modulo);
// actually it's already in result[0][0] of matrix algorithm
// and the second result of the fast doubling algorithm
auto sum = 0ULL;
for (auto i = 1; i <= numPrimes; i++)
{
do
{
n++;
// next Fibonacci number
auto next = (last + current) % Modulo;
last = current;
current = next;
}
while (!isPrime(n));
// if n is prime then add F(n)
sum += current;
// don't overflow
sum %= Modulo;
}
// display result
std::cout << sum << std::endl;
return 0;
}
This solution contains 63 empty lines, 77 comments and 7 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 2.4 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
August 7, 2017 submitted solution
August 7, 2017 added comments
Difficulty
Project Euler ranks this problem at 35% (out of 100%).
Links
projecteuler.net/thread=304 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
Python github.com/nayuki/Project-Euler-solutions/blob/master/python/p304.py (written by Nayuki)
C github.com/LaurentMazare/ProjectEuler/blob/master/e304.c (written by Laurent Mazare)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p304.java (written by Nayuki)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem304.java (written by Magnus Solheim Thrap)
Mathematica github.com/steve98654/ProjectEuler/blob/master/304.nb
Perl github.com/shlomif/project-euler/blob/master/project-euler/407/euler-304-v2.pl (written by Shlomi Fish)
Sage github.com/roosephu/project-euler/blob/master/304.sage (written by Yuping Luo)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 303 - Multiples with small digits | Paper-strip Game - problem 306 >> |